
/*

  KLayout Layout Viewer
  Copyright (C) 2006 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/



#include "layColorPalette.h"

namespace lay
{

static lay::color_t color_table [] = {

  0xff8080, 0xff80a0, 0xff80ff, 
  0xa080ff, 0x8080ff, 0x80a0ff, 
  0xff0000, 0xff0080, 0xff00ff, 
  0x8000ff, 0x0000ff, 0x0080ff, 
  0x800000, 0x800050, 0x800080, 
  0x500080, 0x000080, 0x004080, 

  0x80ffff, 0x80ffa0, 0x00ff80,
  0xa0ff80, 0xffff80, 0xffa080,
  0x00ffff, 0x00ff80, 0x00ff00,
  0x80ff00, 0xffff00, 0xff8000,
  0x008080, 0x008050, 0x008000,
  0x508000, 0x808000, 0x805000,

  0xffffff, 0xc0c0c0, 0x808080,
  0x606060, 0x404040, 0x000000

};

lay::color_t 
ColorPalette::color_by_index (unsigned int n)
{
  return color_table [n % colors ()];
}

unsigned int 
ColorPalette::colors ()
{
  return (sizeof (color_table) / sizeof (color_table [0]));
}

lay::color_t 
ColorPalette::luminous_color_by_index (unsigned int n)
{
  return color_table [n % luminous_colors ()];
}

unsigned int 
ColorPalette::luminous_colors ()
{
  return (sizeof (color_table) / sizeof (color_table [0])) - 6;
}

}
