
/*

  KLayout Layout Viewer
  Copyright (C) 2006 Matthias Koefferlein

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/


#ifndef HDR_layColorPalette
#define HDR_layColorPalette

#include "layViewOp.h"

namespace lay
{

class ColorPalette
{
public:

  /** 
   *  @brief Retrieve the color by index
   */
  static lay::color_t 
  color_by_index (unsigned int n);

  /**
   *  @brief Retrieve the number of colors in the palette
   */
  static unsigned int colors ();

  /** 
   *  @brief Retrieve the luminous color by index
   */
  static lay::color_t 
  luminous_color_by_index (unsigned int n);

  /**
   *  @brief Retrieve the number of luminous of colors in the palette
   *
   *  The luminous colors are used for automatically coloring the
   *  layers for example. They are accessible by color index 0..lc-1,
   *  where lc is the number returned by this functions.
   */
  static unsigned int luminous_colors ();

};

}

#endif

